#include <vector>
#include <algorithm>
#include <memory>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_ttf.h>

//typ vlastn udlosti
Uint32 MY_CUSTOM_EVENT = 0x8001;

int MyEventWatchFirst(void* userdata, SDL_Event* CustomEvent)
{
	if (CustomEvent->type == SDL_KEYDOWN && CustomEvent->key.keysym.scancode == SDL_SCANCODE_O)
		SDL_Log("MyEventWatchFirst");

	if (CustomEvent->type == SDL_KEYDOWN && CustomEvent->key.keysym.scancode == SDL_SCANCODE_I)
		SDL_Log("MyEventWatchFirst"); //neprobhne

	return 0;
};

int MyEventWatchSecond(void* userdata, SDL_Event* CustomEvent)
{
	if (CustomEvent->type == SDL_KEYDOWN && CustomEvent->key.keysym.scancode == SDL_SCANCODE_O)
		SDL_Log("MyEventWatchSecond");

	if (CustomEvent->type == SDL_KEYDOWN && CustomEvent->key.keysym.scancode == SDL_SCANCODE_I)
		SDL_Log("MyEventWatchSecond"); //neprobhne

	return 0;
};

int MyEventFilter(void* userdata, SDL_Event* CustomEvent)
{
	if (CustomEvent->type == SDL_KEYDOWN && CustomEvent->key.keysym.scancode == SDL_SCANCODE_P)
		SDL_Log("MyEventFilter");

	if (CustomEvent->type == SDL_KEYDOWN && CustomEvent->key.keysym.scancode == SDL_SCANCODE_I)
	{
		SDL_Log("MyEventFilter");
		return 0; //udlost nebude vloena do fronty
	}
	return 1;
};



int SDL_main(int, char**)
{
	//inicializace SDL - pouze video
	SDL_Init(SDL_INIT_VIDEO);

	//vytvoen okna
	SDL_Window* MainWindow = SDL_CreateWindow("Fronta udalosti", //jmno okna
		SDL_WINDOWPOS_CENTERED, //okno bude vytvoeno ve stedu obrazovky
		SDL_WINDOWPOS_CENTERED,
		800, 600, NULL); //ka, vka a flagy okna (ty nepotebujeme)


	//vytvoen rendereru
	SDL_Renderer* renderer = SDL_CreateRenderer(MainWindow, -1, SDL_RENDERER_TARGETTEXTURE);

	SDL_LogSetAllPriority(SDL_LOG_PRIORITY_VERBOSE);

	SDL_Event events[255];	//buffer pro udlosti

	SDL_EventState(SDL_WINDOWEVENT, SDL_IGNORE);		//odfiltrovn idlost SDL_WINDOWEVENT

	SDL_AddEventWatch(MyEventWatchFirst, NULL);		//pidn Event Watch
	SDL_AddEventWatch(MyEventWatchSecond, NULL);

	SDL_SetEventFilter(MyEventFilter, NULL);			//pidn filtrovacho callbacku

	int CountOfMyEvent = 0; // kolikrt byl mj event vyvoln


	while (!SDL_QuitRequested())						//zatek hlavn smyky
	{

		while (SDL_PollEvent(events))
		{
			//demonstrace odstrann SDL_MOUSEMOTION po voln SDL_WarpMouseInWindow
			if (events[0].type == SDL_KEYDOWN && events[0].key.keysym.scancode == SDL_SCANCODE_X)
			{
				SDL_Delay(1000); //simulace dlouho trvajc lohy
				SDL_PumpEvents();
				//Pesun myi
				SDL_WarpMouseInWindow(MainWindow, 400, 300);
				//Zsk zbvajc udlosti
				int NumOfOld = SDL_PeepEvents(events, 255, SDL_GETEVENT, SDL_MOUSEMOTION, SDL_MOUSEMOTION);
				SDL_Delay(1000); //simulace dlouho trvajc lohy
				//zskn novch udlost
				SDL_PumpEvents();
				SDL_FlushEvent(SDL_MOUSEMOTION & SDL_MOUSEBUTTONDOWN);
				int NumOfNew = SDL_PeepEvents(events + NumOfOld, 255 - NumOfOld, SDL_GETEVENT, SDL_MOUSEMOTION, SDL_MOUSEMOTION);
				//vrcen udlost zpt do fronty
				SDL_PeepEvents(events, NumOfOld, SDL_ADDEVENT, SDL_MOUSEMOTION, SDL_MOUSEMOTION);
				if (NumOfNew > 1)
					SDL_PeepEvents(events + NumOfOld + 1, NumOfNew - 1, SDL_ADDEVENT, SDL_MOUSEMOTION, SDL_MOUSEMOTION);
			}

			//pidn vlastn udlosti do fronty
			if (events[0].type == SDL_KEYDOWN && events[0].key.keysym.scancode == SDL_SCANCODE_U)
			{
				SDL_Event MyEvent;
				SDL_zero(MyEvent);
				MyEvent.type = MY_CUSTOM_EVENT;
				MyEvent.user.code = ++CountOfMyEvent;
				SDL_PushEvent(&MyEvent);
			}

			//zachycen vlastn udlosti
			if (events[0].type == MY_CUSTOM_EVENT)
				SDL_Log("My event was %i fired", events[0].user.code);
		}




		SDL_SetRenderDrawColor(renderer, 0, 0, 255, 255);		//nastaven barvy, kterou se bude vykreslovat pozad
		SDL_RenderClear(renderer);								//vykreslen pozad

		SDL_RenderPresent(renderer);							//aktualizace okna

		SDL_Delay(1000); //simulace dlohho kolu
	}

	//nen poteba mazat jednotliv objekty, po ukonen programu voln msto automaticky promae OS

	SDL_Quit();								//Ukonen SDL
	return 0;
}